var posix  = require(__dirname + '/build/default/posixtools.node');
var spawn = require('child_process').spawn;
var path  = require('path');

console.log("start: %d", process.pid);

function pathSearch(binary) {
  if (binary.match(/^\//)) { return binary; } // already absolute
  var binpath = null;
  process.env['PATH'].split(':').some(function(p) {
    var bin = path.resolve(p, binary);
    if (path.existsSync(bin)) {
      binpath = bin;
      return true;
    }
    return false;
  });
  return binpath;
}

var binary = pathSearch(process.argv[0]);

if (!process.env['REEXEC']) {
  process.env['REEXEC'] = 1;

  var envp = [];
  for (var k in process.env) {
    envp.push(k + "=" + process.env[k]);
  }
  var argv = process.argv;
  argv.shift();

  reexec_pid = posix.fork();
  if (reexec_pid == 0) {
    // tell all existing file descriptors to close on exec
    for (var i = 3; i < 1024; ++i) { // use getdtablesize?
      posix.fd_close_on_exec(i);
    }
    posix.execve(binary, argv, envp);
  }

  console.log("parent process %d", process.pid);
}
else {
  console.log("next process %d", process.pid);
}
